'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _assign = require('babel-runtime/core-js/object/assign');

var _assign2 = _interopRequireDefault(_assign);

var _defineProperty2 = require('babel-runtime/helpers/defineProperty');

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _extends4 = require('babel-runtime/helpers/extends');

var _extends5 = _interopRequireDefault(_extends4);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _TreeNode = require('./TreeNode');

var _TreeNode2 = _interopRequireDefault(_TreeNode);

var _dataTree = require('./helpers/dataTree');

var _dataTree2 = _interopRequireDefault(_dataTree);

var _util = require('./helpers/util');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Tree = function (_React$Component) {
  (0, _inherits3.default)(Tree, _React$Component);

  function Tree(props) {
    (0, _classCallCheck3.default)(this, Tree);

    var _this = (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(Tree).call(this, props));

    ['onExpand', 'onSelect', 'onCheck'].forEach(function (m) {
      _this[m] = _this[m].bind(_this);
    });

    /**
     * 初始化状态标识
     * 数据一般都是异步加载，在生成Component时，由于props.data为空，导致props.defaultChecked等值无效
     * 这里折中处理下，加一个状态标识，以便在props.data第一次不为空的情况下，取值于defaultChecked，而不是取值于checked
     */
    _this.initial = true;

    _this.state = {
      treeDatas: props.data,
      /**
       * 用来存储当前树选中的checkbox状态
       * @type {Object} key为node.value，value值，1为选中，2为半选中
       */
      checkedMaps: _this.getCheckedMaps(props),
      selectedMaps: _this.getSelectedMaps(props),
      expandedMaps: _this.getExpandedMaps(props, props.data)
    };

    _this.initial = !(props.data && props.data.length > 0);
    /**
     * 存储当前树所有节点的对象，方便后面通过node.value可以获取
     * @type {Object}
     */
    _this.nodeMaps = {};
    /**
     * 这里存储的是选中的节点对象，与state.selectedMaps不同
     * 用于回调props.onChange时使用
     */
    _this.selectedNodes = [];
    _this.checkedNodes = [];
    /**
     * 把数据导入到DataTree中，方便后面搜索用
     */
    _this.dataTree = new _dataTree2.default().import(props.data.slice());

    return _this;
  }

  (0, _createClass3.default)(Tree, [{
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      var _props = this.props;
      var data = _props.data;
      var dataMode = _props.dataMode;
      var checked = _props.checked;
      var selected = _props.selected;
      var expanded = _props.expanded;
      var expandAll = _props.expandAll;
      var _state = this.state;
      var treeDatas = _state.treeDatas;
      var checkedMaps = _state.checkedMaps;
      var selectedMaps = _state.selectedMaps;
      var expandedMaps = _state.expandedMaps;
      // 数据改变时，重设map数据，避免存在脏数据

      if (data !== nextProps.data || dataMode !== nextProps.dataMode) {
        this.nodeMaps = {};
        this.state.selectedMaps = {};
        this.state.checkedMaps = {};
        this.state.expandedMaps = {};

        treeDatas = nextProps.data;
        this.dataTree.import(data.slice());
      }

      if (checked !== nextProps.checked) {
        checkedMaps = this.getCheckedMaps(nextProps);
      }

      if (selected !== nextProps.selected) {
        selectedMaps = this.getSelectedMaps(nextProps);
      }

      if (expanded !== nextProps.expanded || expandAll !== nextProps.expandAll) {
        expandedMaps = this.getExpandedMaps(nextProps, nextProps.data);
      }

      this.initial = !(nextProps.data && nextProps.data.length > 0);

      this.setState({ treeDatas: treeDatas, checkedMaps: checkedMaps, selectedMaps: selectedMaps, expandedMaps: expandedMaps });
    }
  }, {
    key: 'render',
    value: function render() {
      var _wrapperCls,
          _this2 = this;

      var _props2 = this.props;
      var data = _props2.data;
      var animate = _props2.animate;
      var bordered = _props2.bordered;
      var className = _props2.className;
      var style = _props2.style;
      var width = _props2.width;
      var height = _props2.height;
      var prefixCls = _props2.prefixCls;
      var children = _props2.children;
      var otherProps = (0, _objectWithoutProperties3.default)(_props2, ['data', 'animate', 'bordered', 'className', 'style', 'width', 'height', 'prefixCls', 'children']);
      var treeDatas = this.state.treeDatas;

      var wrapperPrefixCls = prefixCls + '-panel';
      var wrapperStyle = (0, _extends5.default)({}, style || {}, { width: width, height: height });
      var wrapperCls = (_wrapperCls = {}, (0, _defineProperty3.default)(_wrapperCls, wrapperPrefixCls, true), (0, _defineProperty3.default)(_wrapperCls, wrapperPrefixCls + '-bordered', bordered), _wrapperCls);
      var treeCls = (0, _defineProperty3.default)({}, prefixCls, true);

      return _react2.default.createElement(
        'div',
        { unselectable: true, style: wrapperStyle, className: (0, _classnames2.default)(className, wrapperCls) },
        _react2.default.createElement(
          'ul',
          (0, _extends5.default)({}, otherProps, { className: (0, _classnames2.default)(treeCls) }),
          treeDatas.map(function (item, index) {
            return _this2.generateTreeNode(item, index);
          })
        )
      );
    }
  }, {
    key: 'getCheckedMaps',
    value: function getCheckedMaps(props) {
      var data = props.data;
      var multiple = props.multiple;
      var commbox = props.commbox;
      var checked = props.checked;
      var defaultChecked = props.defaultChecked;
      // 不是初始化时，只取checked的值，否则优先取值于checked

      var values = (this.initial ? checked || defaultChecked : checked) || [];
      var map = {};

      if (commbox) {
        // 多选情况下，其父、子节点的级联选中状态不作处理，当它传递的值是“有效的”
        // 这和在外面维护checked这个值是一样的，它通过props传递过来，以更新commbox的选中状态
        multiple ? values.forEach(function (item) {
          return map[item] = _util.CHECKBOX_CHECKED;
        }) : map[values[0]] = _util.CHECKBOX_CHECKED;
      }

      // 如果values为空的情况，应当清空原有数据
      if (values.length == 0) {
        this.checkedNodes = [];
      }

      return map;
    }
  }, {
    key: 'getSelectedMaps',
    value: function getSelectedMaps(props) {
      var multiple = props.multiple;
      var selected = props.selected;
      var defaultSelected = props.defaultSelected;
      // 不是初始化时，只取selected的值，否则优先取值于selected

      var values = (this.initial ? selected || defaultSelected : selected) || [];
      var map = {};

      // 单选模式下，只选取第一个值
      multiple ? values.forEach(function (item) {
        return map[item] = true;
      }) : map[values[0]] = true;

      // 如果values为空的情况，应当清空原有数据
      if (values.length == 0) {
        this.selectedNodes = [];
      }

      return map;
    }
  }, {
    key: 'getExpandedMaps',
    value: function getExpandedMaps(props, data) {
      var _this3 = this;

      var expandAll = props.expandAll;
      var expanded = props.expanded;
      var defaultExpanded = props.defaultExpanded;

      var map = {};

      if (expandAll) {
        (data || []).forEach(function (item) {
          map[item.id] = true;
          var children = item.children;
          if (children && children.length > 0) {
            // 递归所有子节点，并合并到map中
            var _map = _this3.getExpandedMaps(props, children);
            (0, _assign2.default)(map, _map);
          }
        });
      } else {
        // 不是初始化时，只取expanded的值，否则优先取值于expanded
        var values = (this.initial ? expanded || defaultExpanded : expanded) || [];
        values.forEach(function (item) {
          return map[item] = true;
        });
      }

      return map;
    }

    /**
     * 渲染树节点
     * @param  {Object} nodeData  节点数据
     * @param  {Number} index  索引值
     * @param  {Object} parentData 父节点数据
     * @param  {Number} prePath  节点路径，根节点的路径为0，它的子节点为0-0, 0-1, ...
     * @return {TreeNode}      节点对象
     */

  }, {
    key: 'generateTreeNode',
    value: function generateTreeNode(nodeData, index, parentData) {
      var _this4 = this;

      var prePath = arguments.length <= 3 || arguments[3] === undefined ? 0 : arguments[3];

      if (!nodeData.id || !nodeData.text) {
        throw 'Error. 节点属性 {id} {text} 不能为空。';
      }

      var _state2 = this.state;
      var expandedMaps = _state2.expandedMaps;
      var selectedMaps = _state2.selectedMaps;
      var checkedMaps = _state2.checkedMaps;
      var _props3 = this.props;
      var multiple = _props3.multiple;
      var commbox = _props3.commbox;
      var animate = _props3.animate;
      var customerNode = _props3.customerNode;
      var value = nodeData.id;
      var text = nodeData.text;
      var children = nodeData.children;

      var path = nodeData.path || prePath + '-' + index;
      var selected = selectedMaps[value] || false;
      var checked = checkedMaps[value] || _util.CHECKBOX_UNCHECKED;
      var expanded = expandedMaps[value] || false;
      var leaf = !children || children.length <= 0;
      var childNodes = void 0;

      var nodeProps = {
        ref: 'node-' + path,
        key: path,
        data: nodeData,
        childData: children,
        parentData: parentData,
        value: value,
        text: text,
        path: path,
        customerNode: customerNode,
        selected: selected,
        checked: checked,
        expanded: expanded,
        leaf: leaf,
        multiple: multiple,
        commbox: commbox,
        onExpand: this.onExpand,
        onSelect: this.onSelect,
        onCheck: this.onCheck
      };

      // 生成已展开的子节点
      if (expanded && children && children.length) {
        childNodes = _react2.default.createElement(
          'ul',
          null,
          children.map(function (item, index) {
            return _this4.generateTreeNode(item, index, nodeData, path);
          })
        );
      }

      // 节点的ref为`node-${path}`的方式，为方便通过ID获取节点对象，这里把node缓存起来
      return this.nodeMaps[value] = _react2.default.createElement(
        _TreeNode2.default,
        nodeProps,
        childNodes
      );
    }

    /**
     * 节点展开、收缩事件，从TreeNode回调过来
     * @param  {Boolean} expanded 标识当前是展开还是收缩动作
     * @param  {TreeNode} node   节点对象        
     */

  }, {
    key: 'onExpand',
    value: function onExpand(expanded, node) {
      // console.log('Tree.onExpand', expanded, node)
      var expandedMaps = this.state.expandedMaps;
      // 如果外面没有传递expanded值过来，即调用setState()更新UI，否则就让外面维护这个状态

      if (!('expanded' in this.props)) {
        this.setState({
          expandedMaps: (0, _extends5.default)({}, expandedMaps, (0, _defineProperty3.default)({}, node.props.value, expanded))
        });
      }
      this.props.onExpand(expanded, node);
    }
  }, {
    key: 'onSelect',
    value: function onSelect(selected, node) {
      // 此处需要合并selected 。
      var selectedMaps = this.state.selectedMaps;
      var _props4 = this.props;
      var multiple = _props4.multiple;
      var commbox = _props4.commbox;
      var onSelect = _props4.onSelect;
      var _node$props = node.props;
      var value = _node$props.value;
      var data = _node$props.data;


      if (onSelect(selected, value, data, node) === false) {
        return;
      }

      // 如果外面没有传递selected值过来，即调用setState()更新UI，否则就让外面维护这个状态
      if (!('selected' in this.props)) {
        // 多选且没有commbox时，才允许选择多个，否则它的选中以commbox为主
        if (multiple && !commbox) {
          this.setState({
            selectedMaps: (0, _extends5.default)({}, selectedMaps, (0, _defineProperty3.default)({}, value, selected))
          });
        } else {
          this.setState({
            selectedMaps: (0, _defineProperty3.default)({}, value, selected)
          });
        }
      }

      // 多选，且有commbox时，不触发其onChange事件，以commbox的check为主
      // 单选，且有commbox时，该onSelect不会被触发，这里不需处理
      if (!(multiple && commbox)) {
        this.setSelectedNodes(selected, data, 'selectedNodes');
        this.fireChange({ selected: selected, value: value, data: data, node: node, selectedNodes: this.selectedNodes });
      }
    }
  }, {
    key: 'onCheck',
    value: function onCheck(checked, node) {
      // console.log('Tree.onCheck', checked, node)
      var _props5 = this.props;
      var multiple = _props5.multiple;
      var commbox = _props5.commbox;
      var _node$props2 = node.props;
      var value = _node$props2.value;
      var data = _node$props2.data;

      var checkState = (0, _util.checkStateToBoolean)(checked);

      if (this.props.onCheck(checkState, value, data, node) === false) {
        return;
      }

      this.toggleCheckState(checked, data);

      // 如果外面没有传递checked值过来，即调用setState()更新UI，否则就让外面维护这个状态
      if (!('checked' in this.props)) {
        this.setState({
          // 在遍历当前节点的父、子节点，并改变它的check state时，并没有调用setState()更新，这里统一处理
          checkedMaps: this.state.checkedMaps,
          // 单选情况下，把selected一起更新
          selectedMaps: !multiple ? (0, _defineProperty3.default)({}, value, (0, _util.checkStateToBoolean)(checked)) : this.state.selectedMaps
        });
      }

      this.fireChange({ selected: checkState, value: value, data: data, node: node, selectedNodes: this.checkedNodes });
    }
  }, {
    key: 'setSelectedNodes',
    value: function setSelectedNodes(selected, data, dataKey) {
      var multiple = this.props.multiple;

      if (multiple) {
        if (selected) {
          this[dataKey].push(data);
        } else {
          this[dataKey] = this[dataKey].filter(function (item) {
            return item.id !== data.id;
          });
        }
      } else {
        this[dataKey] = [data];
      }
    }
    // 此处有更改

  }, {
    key: 'fireChange',
    value: function fireChange(info) {
      var _this5 = this;

      var _props6 = this.props;
      var multiple = _props6.multiple;
      var commbox = _props6.commbox;
      var onChange = _props6.onChange;
      var defaultChecked = _props6.defaultChecked;
      var defaultSeleced = _props6.defaultSeleced;
      var checked = _props6.checked;
      var selected = info.selected;
      var value = info.value;
      var data = info.data;
      var node = info.node;
      var selectedNodes = info.selectedNodes;

      var propsValues = defaultChecked || checked || defaultSeleced || this.props.selected;

      if (multiple) {
        (function () {
          var values = [],
              datas = [];
          selectedNodes.forEach(function (data) {
            values.push(data.id);
            datas.push(data);
          });
          // 如果是选中的情形下
          if (selected) {
            propsValues.forEach(function (item) {
              if (!_this5.contains(item, values)) {
                values.push(item);
                datas.push(_this5.getNodeById(value));
              }
            });
          } else {
            if (!commbox) {
              values = [], datas = [];
              // 找到所在位置
              var index = _this5.indexOf(value, propsValues);

              if (index > -1) {
                propsValues.splice(index, 1);
              }
              propsValues.forEach(function (item) {
                values.push(item);
                datas.push(_this5.getNodeById(item));
              });
            }
          }
          onChange(values, datas, node);
        })();
      } else {
        // 单项选择，在取消选中时，返回空
        selected ? onChange([value], [data], node) : onChange(undefined, undefined, node);
      }
    }
  }, {
    key: 'toggleCheckState',
    value: function toggleCheckState(checked, nodeData) {
      var _props7 = this.props;
      var multiple = _props7.multiple;
      var checkStrictly = _props7.checkStrictly;

      // 不是多选或开启多选严格模式时，选中哪个节点就仅仅选中哪个节点，不作关联操作

      if (!multiple) {
        // 单选
        this.state.checkedMaps = (0, _defineProperty3.default)({}, nodeData.id, checked);
      } else if (multiple && checkStrictly) {
        // 多选，且开启了多选的严格模式
        this.state.checkedMaps[nodeData.id] = checked;
      } else {
        // 级联多选

        if (checked) {
          // 子节点全设为checked
          this.cascade(this.setNodeCheckState, nodeData, _util.CHECKBOX_CHECKED);
          // 父节点全设为partial
          this.bubble(this.setNodeCheckState, nodeData, _util.CHECKBOX_PARTIAL);
        } else {
          // 子节点全设为unchecked
          this.cascade(this.setNodeCheckState, nodeData, _util.CHECKBOX_UNCHECKED);
          // 父节点全设为partial
          this.bubble(this.setNodeCheckState, nodeData, _util.CHECKBOX_PARTIAL);
        }
      }
    }

    /**
     * 根据路径获取节点对象
     * @param  {String} path 节点路径
     * @return {Object}      返回搜索到的节点对象
     */

  }, {
    key: 'findNode',
    value: function findNode(path) {
      return this.refs['node-' + path];
    }

    /**
     * 根据当前节点路径，获取它的父节点路径
     * @param  {String} path 节点路径
     * @return {String}      返回搜索到的节点路径，如果当前节点为根节点，返回空字符
     */

  }, {
    key: 'getParentPath',
    value: function getParentPath(path) {
      return path ? path.substring(0, path.lastIndexOf('-')) : '';
    }
  }, {
    key: 'getParentNode',
    value: function getParentNode(nodeData) {
      var node = this.nodeMaps[nodeData.id] || { props: {} };
      return this.findNode(this.getParentPath(node.props.path));
    }

    /**
     * 设置节点的checkbox的选中状态
     * @param {TreeNode} node       节点对象
     * @param {Number} checkState   选中状态：0，1，2
     */

  }, {
    key: 'setNodeCheckState',
    value: function setNodeCheckState(nodeData, checkState) {
      var _this6 = this;

      // console.log('Tree.check: ', node.props.value, checkState)
      var nodeValue = nodeData.id;
      var checkedMaps = this.state.checkedMaps,
          __checkState = checkState;

      if (checkState === _util.CHECKBOX_PARTIAL) {
        (function () {
          // 重新计算该节点的checked值

          var children = nodeData.children;
          var sumChecked = 0,
              sumPartial = 0;

          children.forEach(function (child) {
            // 这里需要取到TreeNode节点对象，以便获取它现在的选择状态
            var node = _this6.nodeMaps[child.id];
            // 节点的checkState在checkMaps中可能已发生变化，但UI还没更新，这里需要从checkedMaps中获取它最新的checkState
            var childCheckState = checkedMaps[node.props.value] !== undefined ? checkedMaps[node.props.value] : node.props.checked;

            if (childCheckState === _util.CHECKBOX_CHECKED) {
              sumChecked++;
            } else if (childCheckState === _util.CHECKBOX_PARTIAL) {
              sumPartial++;
            }
          });

          __checkState = children.length === sumChecked ? _util.CHECKBOX_CHECKED : sumChecked > 0 || sumPartial > 0 ? _util.CHECKBOX_PARTIAL : _util.CHECKBOX_UNCHECKED;
        })();
      }

      this.setSelectedNodes((0, _util.checkStateToBoolean)(__checkState), nodeData, 'checkedNodes');
      // 这里不使用setState()，避免多次更新UI，赋值完成后，将在onCheck()中统一更新
      checkedMaps[nodeValue] = __checkState;
    }

    /**
     * 冒泡(遍历所有父节点)
     * @param  {Function} cb   [description]
     * @param  {[type]}   nodeData [description]
     * @param  {[type]}   checkState [description]
     * @return {[type]}        [description]
     */

  }, {
    key: 'bubble',
    value: function bubble(cb, nodeData, checkState) {
      var parentNode = this.getParentNode(nodeData);
      while (parentNode) {
        var parentData = parentNode.props.data;
        if (cb.call(this, parentData, checkState) === false) {
          break;
        }
        parentNode = this.getParentNode(parentData);
      }
    }
    /**
     * 瀑布(遍历所有子节点)
     * @param  {Function} cb   [description]
     * @param  {[type]}   nodeData [description]
     * @param  {[type]}   checkState [description]
     * @return {[type]}        [description]
     */

  }, {
    key: 'cascade',
    value: function cascade(cb, nodeData, checkState) {
      var _this7 = this;

      if (cb.call(this, nodeData, checkState) !== false) {
        nodeData.children && nodeData.children.length && nodeData.children.forEach(function (child) {
          _this7.cascade(cb, child, checkState);
        });
      }
    }

    /**
     * 包含 contains 
     * @return {[type]} [description]
     */

  }, {
    key: 'contains',
    value: function contains(id, container) {
      var bool = false;
      container.forEach(function (item) {
        if (item === id) {
          return bool = true;
        }
      });
      return bool;
    }
  }, {
    key: 'indexOf',
    value: function indexOf(id, container) {
      var i = -1;
      container.forEach(function (item, key) {
        if (item === id) {
          return i = key;
        }
      });
      return i;
    }
  }, {
    key: 'getNodeById',
    value: function getNodeById(id) {
      var tree = this.dataTree;
      var targetNode = null;
      tree.traverseDFS(function (node) {
        // 如果存在多各根节点的情形
        if (node._depth == 1 && node._childNodes.length > 1) {
          node._childNodes.forEach(function (nodeItem) {
            if (nodeItem._data.id === id) {
              return targetNode = nodeItem._data;
            }
          });
        } else {
          if (node._data.id === id) {
            targetNode = node._data;
          }
        }
      });
      return targetNode;
    }
  }, {
    key: 'getDirectParentNode',
    value: function getDirectParentNode(id) {
      var tree = this.dataTree;
      var targetNode = null;
      tree.traverseDFS(function (node) {
        // 如果存在多各根节点的情形
        if (node._depth == 1 && node._childNodes.length > 1) {
          node._childNodes.forEach(function (nodeItem) {
            nodeItem.getAncestry().forEach(function (item) {
              item._data.children.forEach(function (child) {
                if (child.id == id) {
                  return targetNode = item._data;
                }
              });
            });
          });
        } else {
          node.getAncestry().forEach(function (item) {
            item._data.children.forEach(function (child) {
              if (child.id == id) {
                return targetNode = item._data;
              }
            });
          });
        }
      });
      return targetNode;
    }
  }]);
  return Tree;
}(_react2.default.Component);

Tree.propTypes = {
  width: _react.PropTypes.oneOfType([_react.PropTypes.number, _react.PropTypes.string]),
  height: _react.PropTypes.oneOfType([_react.PropTypes.number, _react.PropTypes.string]),
  /**
   * 树组件的data数据集
   */
  data: _react.PropTypes.array.isRequired,
  /**
   * 根节点
   */
  rootNode: _react.PropTypes.oneOfType([_react.PropTypes.bool, _react.PropTypes.element]),
  /**
   * 是否在展开、收缩节点时添加动画
   */
  animate: _react.PropTypes.bool,
  /**
   * 是否展开所有节点
   */
  expandAll: _react.PropTypes.bool,
  /**
   * 选中的节点
   */
  selected: _react.PropTypes.array,
  /**
   * 默认选中的节点，注意与selected的区别
   * 当selected给了值后，在选中行时，Tree内部不会调用setState()更新UI，需要外面把更新后的selected传递过来
   * 下面的checked, defaultChecked也是如此
   */
  defaultSelected: _react.PropTypes.array,
  /**
   * 选中的节点（指选中它的checkbox或radio，仅commbox=true时有效）
   */
  checked: _react.PropTypes.array,
  /**
   * 默认选中的节点
   */
  defaultChecked: _react.PropTypes.array,
  /**
   * 展开的节点
   */
  expanded: _react.PropTypes.array,
  /**
   * 默认展开的节点
   */
  defaultExpanded: _react.PropTypes.array,
  /**
   * 是否显示commbox
   */
  commbox: _react.PropTypes.bool,
  /**
   * 是否多选
   * @type {[type]}
   */
  multiple: _react.PropTypes.bool,
  /**
   * 是否开启多选的严格模式，开启时，选中节点时，不会同时选中它的父节点或子节点
   */
  checkStrictly: _react.PropTypes.bool,
  /**
   * 是否显示border
   */
  bordered: _react.PropTypes.bool,
  /**
   * 展开、收缩节点时的回调事件
   * @type {[function(isExpanded, node)]}
   */
  onExpand: _react.PropTypes.func,
  /**
   * 选中节点时的回调事件（在commbox=true时无效）
   * @type {[function(isSelected, value, data, node)]}
   */
  onSelect: _react.PropTypes.func,
  /**
   * 选中commbox时的回调事件（仅commbox=true时有效）
   * @type {[function(isChecked, value, data, node)]}
   */
  onCheck: _react.PropTypes.func,
  /**
   * 选中的节点发生变化时的回调事件
   * @type {[function(value, data, node)]}
   */
  onChange: _react.PropTypes.func,
  /**
   * 增加自定义的节点
   * @type {[function(node)]}
   */
  customerNode: _react.PropTypes.shape({
    onAdd: _react.PropTypes.func, // 添加函数
    hover: _react.PropTypes.bool // 触发点
  })
};

Tree.defaultProps = {
  prefixCls: 'rt-tree',
  animate: true,
  bordered: true,
  useArrow: true,
  onExpand: _util.noop,
  onSelect: _util.noop,
  onCheck: _util.noop,
  onChange: _util.noop
};

Tree.elementType = 'Tree';

exports.default = Tree;