'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _defineProperty2 = require('babel-runtime/helpers/defineProperty');

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _jquery = require('jquery');

var _jquery2 = _interopRequireDefault(_jquery);

var _util = require('./helpers/util');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

window.$ = window.jQuery = _jquery2.default;

var TreeNode = function (_React$Component) {
  (0, _inherits3.default)(TreeNode, _React$Component);

  function TreeNode(props) {
    (0, _classCallCheck3.default)(this, TreeNode);

    var _this = (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(TreeNode).call(this, props));

    ['onExpand', 'onSelect', 'onCheck'].forEach(function (m) {
      _this[m] = _this[m].bind(_this);
    });
    return _this;
  }

  (0, _createClass3.default)(TreeNode, [{
    key: 'render',
    value: function render() {
      var _classes;

      var props = this.props;
      var value = props.value;
      var text = props.text;
      var selected = props.selected;
      var multiple = props.multiple;
      var commbox = props.commbox;
      var checked = props.checked;
      var expanded = props.expanded;
      var qtip = props.qtip;
      var prefixCls = props.prefixCls;
      var className = props.className;
      var children = props.children;
      var customerNode = props.customerNode;

      var classes = (_classes = {}, (0, _defineProperty3.default)(_classes, prefixCls, true), (0, _defineProperty3.default)(_classes, prefixCls + '-expanded', expanded), (0, _defineProperty3.default)(_classes, prefixCls + '-selected', selected), (0, _defineProperty3.default)(_classes, prefixCls + '-checked', checked), _classes);

      return _react2.default.createElement(
        'li',
        { className: (0, _classnames2.default)(className, classes), onMouseOver: this.handleHoverCustomer.bind(this, 'in'), onMouseOut: this.handleHoverCustomer.bind(this, 'out'), 'aria-value': value, 'aria-expanded': expanded, 'aria-selected': selected },
        this.isLeaf() ? _react2.default.createElement('i', null) : _react2.default.createElement('i', { className: 'icon-arrow', onClick: this.onExpand }),
        this.renderCommbox(),
        _react2.default.createElement(
          'a',
          { onClick: this.onSelect, onDoubleClick: this.onExpand, title: qtip || text },
          text
        ),
        children,
        customerNode && this.renderCustomerNode()
      );
    }
  }, {
    key: 'renderCommbox',
    value: function renderCommbox() {
      var _props = this.props;
      var multiple = _props.multiple;
      var commbox = _props.commbox;
      var checked = _props.checked;

      if (!commbox) {
        return null;
      }

      var commboxPrefixCls = multiple ? 'icon-checkbox' : 'icon-radio';
      var commboxCls = commboxPrefixCls + '-' + checked;

      return _react2.default.createElement('i', { className: commboxCls, onClick: this.onCheck, 'aria-checked': checked });
    }
  }, {
    key: 'renderCustomerNode',
    value: function renderCustomerNode() {
      var _props2 = this.props;
      var customerNode = _props2.customerNode;
      var data = _props2.data;

      return customerNode.onAdd && _react2.default.createElement(
        'div',
        { className: (0, _classnames2.default)('customer-node', { hover: customerNode.hover }) },
        customerNode.onAdd(data)
      );
    }
  }, {
    key: 'isLeaf',
    value: function isLeaf() {
      var _props3 = this.props;
      var leaf = _props3.leaf;
      var expanded = _props3.expanded;
      var children = _props3.children;

      return leaf || expanded && !children;
    }

    /**
     * 渲染子节点
     */

  }, {
    key: 'renderChildren',
    value: function renderChildren() {
      var _this2 = this;

      var _props4 = this.props;
      var tree = _props4.tree;
      var path = _props4.path;
      var expanded = _props4.expanded;
      var children = _props4.children;

      if (!tree || !children || !expanded) {
        return null;
      }

      return _react2.default.createElement(
        'ul',
        null,
        _react2.default.Children.map(children, function (child, index) {
          return tree.renderTreeNode(child, index, _this2, path);
        }, tree)
      );
    }
  }, {
    key: 'handleHoverCustomer',
    value: function handleHoverCustomer(type, e) {
      e.stopPropagation();
      var _props5 = this.props;
      var customerNode = _props5.customerNode;
      var prefixCls = _props5.prefixCls;

      if (!(customerNode && customerNode.hover)) return false;

      var target = (0, _jquery2.default)(e.target);

      var straigtNode = target.hasClass(prefixCls) ? target : target.closest('.' + prefixCls);

      switch (type) {
        case 'in':
          {
            straigtNode.children('.customer-node').show();
          };break;
        case 'out':
          {
            straigtNode.find('.customer-node').hide();
          };break;
      }
    }
  }, {
    key: 'onExpand',
    value: function onExpand(e) {
      var _props6 = this.props;
      var expanded = _props6.expanded;
      var onExpand = _props6.onExpand;

      onExpand(!expanded, this);
    }
  }, {
    key: 'onSelect',
    value: function onSelect() {
      var _props7 = this.props;
      var multiple = _props7.multiple;
      var commbox = _props7.commbox;
      var selected = _props7.selected;
      var onSelect = _props7.onSelect;
      var onCheck = _props7.onCheck;
      // 单选，且存在commbox时，触发其onCheck事件

      if (!multiple && commbox) {
        onCheck((0, _util.booleanToCheckState)(!selected), this);
      } else {
        // 单选变更为已经选中的情况再次点击就直接关闭
        //
        multiple ? onSelect(!selected, this) : onSelect(true, this);
      }
    }
  }, {
    key: 'onCheck',
    value: function onCheck() {
      var _props8 = this.props;
      var checked = _props8.checked;
      var onCheck = _props8.onCheck;
      // 选中状态，点击后，设为未选中状态，而半选或未选中状态在点击后，都将设为选中状态

      onCheck(checked === _util.CHECKBOX_CHECKED ? _util.CHECKBOX_UNCHECKED : _util.CHECKBOX_CHECKED, this);
    }
  }]);
  return TreeNode;
}(_react2.default.Component);

TreeNode.propTypes = {
  /**
   * 节点value(ID)
   */
  value: _react.PropTypes.string.isRequired,
  /**
   * 节点显示的文本信息
   */
  text: _react.PropTypes.string.isRequired,
  /**
   * 节点的提示信息
   */
  qtip: _react.PropTypes.string,
  /**
   * 是否选中
   */
  selected: _react.PropTypes.bool,
  /**
   * 是否选中checkbox（仅在commbox=true时有效）
   * 其中0为未选中，1为选中，2为半选中
   */
  checked: _react.PropTypes.number,
  /**
   * 是否多选
   * @type {[type]}
   */
  multiple: _react.PropTypes.bool,
  /**
   * 是否显示复选框（多选模式）
   */
  commbox: _react.PropTypes.bool,
  /**
   * 是否展开
   */
  expanded: _react.PropTypes.bool,
  /**
   * 是否设为disable，让它不可选
   */
  disabled: _react.PropTypes.bool,
  /**
   * 是否为叶节点
   */
  leaf: _react.PropTypes.bool,
  /**
   * 是否显示节点箭头
   */
  useArrow: _react.PropTypes.bool,
  /**
   * 选取节点时的回调事件
   * @type {[function(isSelected, node)]}
   */
  onSelect: _react.PropTypes.func,
  /**
   * 选取commbox时的回调事件
   * @type {[function(isChecked, node)]}
   */
  onCheck: _react.PropTypes.func,
  /**
   * 展开或收缩节点时的回调事件
   * @type {[function(isExpanded, node)]}
   */
  onExpand: _react.PropTypes.func,
  /**
   * 增加自定义的节点
   * @type {[function(node)]}
   */
  customerNode: _react.PropTypes.shape({
    onAdd: _react.PropTypes.func, // 添加函数
    hover: _react.PropTypes.bool // 触发点
  })
};

TreeNode.defaultProps = {
  prefixCls: 'rt-tree-node',
  onSelect: _util.noop,
  onCheck: _util.noop,
  onExpand: _util.noop
};

exports.default = TreeNode;